#!/bin/bash

tests="admin_set_web git_big_push admin_set_git by_http wh_lambda http_keys \
	http_forgot \
	api wh_cloud pr_anon wh_http ssh http_totp totp git_log1 \
	http_admin http_bug \
	http_create_account http_login http_settings http_csrf http_top \
	token util log state cache prof event rights keys user repo git \
	bug hook_update git2 source"

failed=""
add=""
for t in ${tests}; do
	if [ -r "state/${t}" ]; then
		continue
	fi

	echo
	echo "${t}: Running..."
	if [ -r "${t}.sh" ]; then
		./${t}.sh
	else
		php ${t}.php
	fi
	if [ "${?}" != "0" ]; then
		failed="${failed}${add}${t}"
		add=" "
		echo "${t}: FAILED!"
	else
		touch "state/${t}"
	fi
done

echo "${failed}" > _run_tests.failed

echo

if [ "${failed}" = "" ]; then
	exit 0
fi

echo "Some tests failed: ${failed}"
exit 1
