<?php
error_reporting(E_ALL | E_STRICT);
ini_set('track_errors', 'On');

$rg_cache_debug = TRUE;

$INC = dirname(__FILE__) . '/../inc';
require_once(dirname(__FILE__) . '/config.php');
require_once($INC . '/init.inc.php');
require_once($INC . '/util.inc.php');
require_once('helpers.inc.php');
require_once('http.inc.php');

rg_log_set_file('admin_set_web.log');

$rg_sql = 'host=localhost user=rocketgit dbname=rocketgit connect_timeout=10';
$rg_no_db = TRUE;
require_once('common.php');

$_testns = 'admin_set_web';
$rg_cache_enable = TRUE;
$rg_cache_debug = TRUE;

prepare_http();

$rg_ui = array('is_admin' => 1);
rg_test_create_user($db, $rg_ui);
test_login($test_url, $rg_ui);


rg_log('');
rg_log_enter('Loading Admin -> Settings -> Web...');
$data = array();
$headers = array();
$r = do_req($test_url . '/op/admin/settings/web', $data, $headers);
if ($r === FALSE) {
	rg_log("Cannot load page!");
	exit(1);
}
if (!isset($r['tokens']['admin_settings_web'])) {
	rg_log_ml('r:' . print_r($r, TRUE));
	rg_log("No 'admin_settings_web' token?!");
	exit(1);
}
$token = $r['tokens']['admin_settings_web'];

rg_log('Posting the form...');
$data = array(
	'doit' => 1,
	'token' => $token
);
$list = array(
	'hostname' => '',
	'http_allow' => '',
	'https_allow' => ''
);
foreach ($list as $var => $def) {
	$v = rg_state_get($db, $var);
	if ($v === FALSE) {
		rg_log('Cannot load state!');
		exit(1);
	}
	if (empty($v))
		$data[$var] = $def;
	else
		$data[$var] = $v;
}
$r = do_req($test_url . '/op/admin/settings/web', $data, $headers);
if (!strstr($r['body'], 'Configuration has been successfully saved.')) {
	rg_log_ml('r: ' . print_r($r, TRUE));
	rg_log("Cannot post form!");
	exit(1);
}
rg_log_exit();


rg_log('OK!');
?>
