<?php
error_reporting(E_ALL | E_STRICT);
ini_set("track_errors", "On");

$INC = dirname(__FILE__) . "/../inc";
require_once(dirname(__FILE__) . "/config.php");
require_once($INC . "/init.inc.php");
require_once($INC . "/log.inc.php");
require_once($INC . "/sql.inc.php");
require_once($INC . "/struct.inc.php");
require_once($INC . "/state.inc.php");

rg_log_set_file("state.log");

require_once("common.php");

$rg_sql_debug = 1;
$rg_cache_debug = TRUE;

$k = 'key-' . rg_id(16);

rg_log('');
rg_log_enter('Checking return for an non-existing key...');
$r = rg_state_get($db, $k);
if ($r !== "") {
	rg_log("Cannot get '' (but '$r') for an unknown key!");
	exit(1);
}
rg_log_exit();


rg_log('');
rg_log_enter('Setting key to "bau"...');
$r = rg_state_set($db, $k, "bau");
if ($r !== TRUE) {
	rg_log("Cannot get a TRUE for setting 'a' to 'bau' ($r)!");
	exit(1);
}
rg_log_exit();


rg_log('');
rg_log_enter('Setting key to "bau" (again)...');
$r = rg_state_set($db, $k, "bau");
if ($r !== TRUE) {
	rg_log("Cannot get a TRUE for setting 'a' to 'bau' ($r)!");
	exit(1);
}
rg_log_exit();


rg_log('');
rg_log_enter('Overwriting var with "cucu"...');
$r = rg_state_set($db, $k, "cucu");
if ($r !== TRUE) {
	rg_log("Cannot get a TRUE for setting 'a' to 'cucu' ($r)!");
	exit(1);
}
rg_log_exit();


rg_log('');
rg_log_enter('Checking if state is correctly now...');
$r = rg_state_get($db, $k);
if (strcmp($r, "cucu") != 0) {
	rg_log("Cannot get correct state ('$r' != 'cucu')!");
	exit(1);
}
rg_log_exit();


rg_log("OK!");
?>
